#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <commdlg.h>
#include <time.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/timeb.h>
#include <stdlib.h>

#include <string>
#include <vector>
using namespace std;

#define	    COMPRESSION_NONE        1	/* dump mode */
#define	    COMPRESSION_CCITTRLE    2	/* CCITT modified Huffman RLE */
#define	    COMPRESSION_CCITTFAX3   3	/* CCITT Group 3 fax encoding */
#define	    COMPRESSION_CCITTFAX4   4	/* CCITT Group 4 fax encoding */
#define	    COMPRESSION_LZW         5       /* Lempel-Ziv  & Welch */
#define	    COMPRESSION_JPEG        7	/* %JPEG DCT compression */
#define	    COMPRESSION_PACKBITS    32773	/* Macintosh RLE */
#define	    COMPRESSION_CLASSF      88888888
#define	    COMPRESSION_CLASSF196   88888889

void GetModulePath(char *out_path,char *in_name)
{
	char *p;
	GetModuleFileName(NULL,out_path,256);
	p =strrchr(out_path,'\\');
	p[1]=0;
	strcat(out_path,in_name);
}

typedef void (__stdcall *VeryPDF_PSToImageSetCodeFunc)(const char *lpCode);
typedef BOOL (__stdcall *VeryPDF_PSToImageConverterFunc)(LPCTSTR lpPSFile, LPCTSTR lpImageFile, int nIsWidthAndHeight,
			int xResORWidth, int yResORHeight, int nCompression, BOOL bIsMultiPage,
			int nFirstPage, int nLastPage, int nQuality, int nBitCount, BOOL bGrayscale,
			LPCTSTR lpUserPassword, LPCTSTR lpOwnPassword, BOOL bTransparentBackground);
typedef BOOL (__stdcall *VeryPDF_PSToImageConverter2Func)(LPCTSTR lpPSFile, LPCTSTR lpImageFile, int nIsWidthAndHeight,
			int xResORWidth, int yResORHeight, int nCompression, BOOL bIsMultiPage,
			int nFirstPage, int nLastPage, int nQuality, int nBitCount, BOOL bGrayscale,
			LPCTSTR lpUserPassword, LPCTSTR lpOwnPassword, BOOL bTransparentBackground);
typedef void (__stdcall *VeryPDF_PSToImageSetOptionsFunc)(LPCTSTR ptrKey, LPCTSTR ptrValue);
			
VeryPDF_PSToImageSetCodeFunc VeryPDF_PSToImageSetCode = NULL;
VeryPDF_PSToImageConverterFunc VeryPDF_PSToImageConverter = NULL;
VeryPDF_PSToImageConverter2Func VeryPDF_PSToImageConverter2 = NULL;
VeryPDF_PSToImageSetOptionsFunc VeryPDF_PSToImageSetOptions = NULL;

HINSTANCE g_hPS2ImageSDK = NULL;

BOOL LoadDLLSDK()
{
	char path[_MAX_PATH];
	GetModulePath(path,"ps2imgsdk.dll");
	g_hPS2ImageSDK = LoadLibrary(path);
	if(g_hPS2ImageSDK == NULL)
		return FALSE;
	VeryPDF_PSToImageSetCode=(VeryPDF_PSToImageSetCodeFunc)GetProcAddress(g_hPS2ImageSDK,"VeryPDF_PSToImageSetCode");
	if(VeryPDF_PSToImageSetCode==NULL)
		return FALSE;
	VeryPDF_PSToImageConverter=(VeryPDF_PSToImageConverterFunc)GetProcAddress(g_hPS2ImageSDK,"VeryPDF_PSToImageConverter");
	if(VeryPDF_PSToImageConverter==NULL)
		return FALSE;
	VeryPDF_PSToImageConverter2=(VeryPDF_PSToImageConverterFunc)GetProcAddress(g_hPS2ImageSDK,"VeryPDF_PSToImageConverter2");
	if(VeryPDF_PSToImageConverter2==NULL)
		return FALSE;
	VeryPDF_PSToImageSetOptions=(VeryPDF_PSToImageSetOptionsFunc)GetProcAddress(g_hPS2ImageSDK,"VeryPDF_PSToImageSetOptions");
	if(VeryPDF_PSToImageSetOptions==NULL)
		return FALSE;
	return TRUE;	
}
void FreeDLLSDK()
{
	if(g_hPS2ImageSDK)
		FreeLibrary(g_hPS2ImageSDK);
}

int main(int argc, char *argv[])
{
	if(argc != 3)
	{
		printf("Usage: test.exe file.ps file.png\n");
		return FALSE;
	}
	BOOL nRet = FALSE;
	LoadDLLSDK();

	VeryPDF_PSToImageSetCode("XXXXXXXXXXXXXXXXXXXXXXXX");
	
	string strInPSFile = argv[1];
	string strOutImageFile = argv[2];

	char szOutImageFile[300] = {0};

	CHAR drive[_MAX_DRIVE],dir[_MAX_DIR],fname[_MAX_FNAME],ext[_MAX_EXT];
	_splitpath(strOutImageFile.c_str(), drive, dir, fname, ext );
	strcat(fname, "-1");
	_makepath(szOutImageFile, drive, dir, fname, ext);

	
	nRet = VeryPDF_PSToImageConverter(strInPSFile.c_str(), szOutImageFile,
		FALSE,200,200,COMPRESSION_PACKBITS, FALSE, -1, -1, 100, 24, FALSE, NULL, NULL, 0);

	VeryPDF_PSToImageSetOptions("AutoTrimImage", "1");
	_splitpath(strOutImageFile.c_str(), drive, dir, fname, ext );
	strcat(fname, "-2");
	_makepath(szOutImageFile, drive, dir, fname, ext);
	nRet = VeryPDF_PSToImageConverter2(strInPSFile.c_str(), szOutImageFile,
		FALSE,800,800,COMPRESSION_PACKBITS, FALSE, -1, -1, 100, 24, FALSE, NULL, NULL, 2);
	
	FreeDLLSDK();
	return nRet;
}